SystemOrganization addCategory: #'CS528-SetbackProject'!
SystemOrganization addCategory: #'CS528-SetbackProject-Tests'!

TestCase subclass: #SetbackTestCase
	instanceVariableNames: 'sortedDeck oneHeart oneDiamond oneClub oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

SetbackTestCase subclass: #CardHandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandAdditionCapacity
|hand deck|
deck:= (FrenchDeck createStandardDeck).
hand:= (SetbackPlayerHand addCard: deck dealNext).
self assert: (hand cards size) = 1.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 2.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 3.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 4.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 5.
(hand addCard: deck dealNext).
self assert: (hand cards size) = 6.
self should: [ (hand addCard: deck dealNext). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandRemovalCapacity
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(hand removeCard: card).
self should: [ (hand removeCard: card). ] raise: TestResult error.
! !

!CardHandTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testHandUniqueness
|hand card|
card:= (Card value: #two suit: #hearts).
hand:= (SetbackPlayerHand addCard: card).
self assert: (hand capacity) = 6.
self assert: (hand cards size) = 1.
(SetbackPlayerHand addCard: card).
self assert: (hand cards size) = 1.! !

SetbackTestCase subclass: #CardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testCardUniqueness
|card|
card:= (Card value: #two suit: #hearts).
self should: [ card value: #two suit: #hearts ] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/28/2013 15:29'!
testInvalidCardCreation
self should: [(Card value: #two unit: #two)] raise: TestResult error.
self should: [(Card value: #hearts unit: #hearts)] raise: TestResult error.! !

!CardTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 11:07'!
testSimpleCardCreation
self assert: ((Card value: #two suit: #hearts) value) = #two.
self assert: ((Card value: #two suit: #hearts) suit) = #hearts.! !

SetbackTestCase subclass: #DeckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckCreation
self assert: (FrenchDeck new cards = nil).
self assert: (FrenchDeck createStandardDeck cards size = 52).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ace suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #king suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #queen suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #jack suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #ten suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #nine suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #eight suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #seven suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #six suit: #clubs)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #five suit: #hearts)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #four suit: #diamonds)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #three suit: #spades)).
self assert: (FrenchDeck createStandardDeck cards includes: (Card value: #two suit: #clubs)).! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckDealing
|deck|
deck:= FrenchDeck createStandardDeck.
1 to: 52 do: [ :i | deck dealNext ].
self should: [deck dealNext] raise: TestResult error.! !

!DeckTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 07:58'!
testDeckSingleton
|deck|
deck:= FrenchDeck createStandardDeck.
self should: [(deck createStandardDeck )] raise: TestResult error.! !

SetbackTestCase subclass: #SetbackGameTest
	instanceVariableNames: 'player1 player2 player3 hand ll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 18:10'!
dealAndBidPhases
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: (ThreePlayerStrategy new) winnerStrat: (StandardWinStrategy new).
hand startDealPhase.
hand startBidPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
"player one wins the bid"! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 18:34'!
testBasicTrickPhase
self dealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
hand startTrickPhase.
"hearts as trump"
player1 playCard: (sortedDeck at: 18).
self assert: (player1 hand cards size) =  5.
"can't play diamonds"
self should: [player2 playCard: (sortedDeck at: 21)] raise: TestResult error.
player2 playCard: (sortedDeck at: 22).
self assert: (player2 hand cards size) =  5.
player3 playCard: (sortedDeck at: 10).
self assert: (player3 hand cards size) =  5.
"the trick is over according to our player configuration"
self assert: (player2 cardsWon size) = 3.
! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 21:27'!
testFullTrickPhase
self dealAndBidPhases.
player1 hand: oneClub.
player2 hand: oneSpade.
player3 hand: oneDiamond.
hand startTrickPhase.
"hearts as trump - player 2 wins trick"
player1 playCard: (sortedDeck at: 18).
player2 playCard: (sortedDeck at: 22).
player3 playCard: (sortedDeck at: 10).
"trick 2 - player 2 wins"
player1 playCard: (sortedDeck at: 13).
"we shouldn't be listening to player 1, only player 2 who is next to throw"
self assert: (player1 hand cards size) =  5.
player2 playCard: (sortedDeck at: 25).
player3 playCard: (sortedDeck at: 41).
player1 playCard: (sortedDeck at: 17).
"trick 3 - player 2 wins"
player2 playCard: (sortedDeck at: 19).
player3 playCard: (sortedDeck at: 11).
player1 playCard: (sortedDeck at: 15).
"trick 4 - player 3 wins"
player2 playCard: (sortedDeck at: 20).
player3 playCard: (sortedDeck at: 8).
player1 playCard: (sortedDeck at: 16).
"trick 5 - player 3 wins"
player3 playCard: (sortedDeck at: 12).
player1 playCard: (sortedDeck at: 13).
player2 playCard: (sortedDeck at: 21).
"trick 6 - player 3 wins"
player3 playCard: (sortedDeck at: 50).
player1 playCard: (sortedDeck at: 14).
player2 playCard: (sortedDeck at: 23).

self assert: (player1 hand cards size) = 0.
self assert: (player2 hand cards size) = 0.
self assert: (player3 hand cards size) = 0.
self assert: (player1 cardsWon size) = 0.
self assert: (player2 cardsWon size) = 9.
self assert: (player3 cardsWon size) = 9.
self assert: (hand trump) = #hearts.
hand startScorePhase.
self assert: player1 pointsEarned = -2.
self assert: player2 pointsEarned = 1.
self assert: player3  pointsEarned = 2.! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 19:17'!
testGameCreation
|player1 player2 player3 game|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
game:= SetbackGame setUpGame.
game addPlayer: player1.
game addPlayer: player2.
game addPlayer: player3.
game startGame.

self assert: game started = true.
! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:58'!
testGameStartAndBid
|player1 player2 player3 hand ll|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil.
hand startBidPhase.
player2 makeBid: #pass.
player3 makeBid: #pass.
player1 makeBid: #pass.
self assert: hand bidder = player1. 
self assert: hand currentBid = #two. ! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:58'!
testGameStartAndBid2
|player1 player2 player3 hand ll|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil.
hand startBidPhase.
player2 makeBid: #two.
player3 makeBid: #three.
player1 makeBid: #two.
self assert: hand bidder = player3. 
self assert: hand currentBid = #three. ! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:58'!
testGameStartAndDealerStealsBid
|player1 player2 player3 hand ll|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
(ll add: player3).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil.
hand startBidPhase.
player2 makeBid: #two.
player3 makeBid: #pass.
player1 makeBid: #two.
self assert: hand bidder = player1. 
self assert: hand currentBid = #two. ! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 19:26'!
testInvalidGameCreation
|player1 player2 player3 player4 game|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
player3:= SetbackPlayer name: 'Adam'.
player4:= SetbackPlayer name: 'Homer'.
game:= SetbackGame setUpGame.
game addPlayer: player1.
self should: [ game startGame ] raise: TestResult error.
game addPlayer: player2.
game addPlayer: player3.
self should: [ game addPlayer: player4. ] raise: TestResult error.
self should: [ game startNewHand ] raise: TestResult error.
game startGame.
self should: [ game playerConfigStrategy: ThreePlayerStrategy new. ] raise: TestResult error.
self should: [ game winnerStrategy: StandardWinStrategy new. ] raise: TestResult error.
! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:58'!
testPlayerDealing
|player1 player2 hand ll|
player1:= SetbackPlayer name: 'Terry'.
player2:= SetbackPlayer name: 'Joe'.
ll:= LinkedList new.
(ll add: player1).
(ll add: player2).
hand:= SetbackGameHand players: ll playerConfig: nil winnerStrat: nil.
hand startDealPhase.
self assert: (player1 hand cards size) = 6.
self assert: (player2 hand cards size) = 6.! !

!SetbackGameTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:12'!
testScorePhase
self dealAndBidPhases.
player1 winTrick: oneClub cards.
player2 winTrick: oneSpade cards.
player3 winTrick: oneDiamond cards.
ScorePhase players: ll trump: #clubs bidder: player3 bid: #two.
self assert: player1 pointsEarned = 0.
self assert: player1 gamePointsWon = 0.
self assert: player2 pointsEarned = 1.
self assert: player2 gamePointsWon = 9.
self assert: player3 pointsEarned = 2.
self assert: player3 gamePointsWon = 15.
! !

SetbackTestCase subclass: #SetbackPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackPlayerTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 09:32'!
testPlayerCreation
self assert: (SetbackPlayer name: 'Terry') name = 'Terry'.
self assert: (SetbackPlayer name: 'Terry') hand cards size = 0.
self assert: (SetbackPlayer name: 'Terry') pointsEarned = 0.
self assert: (SetbackPlayer name: 'Terry') cardsWon size = 0.! !

!SetbackPlayerTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 16:24'!
testPlayerEquality
self assert: (SetbackPlayer name: 'Terry') ~= (SetbackPlayer name: 'Terry')! !

!SetbackTestCase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/5/2013 18:52'!
setUp
sortedDeck:= FrenchDeck new populateFrenchDeck.

oneHeart:= SetbackPlayerHand addCard: (sortedDeck at: 1). "4 of diamonds"
oneHeart 
	addCard: (sortedDeck at: 2); " 4 of hearts"
	addCard: (sortedDeck at: 3); " 4 of clubs"
	addCard: (sortedDeck at: 4); " 4 of spades"
	addCard: (sortedDeck at: 5); "10 of diamonds"
	addCard: (sortedDeck at: 7). " 10 of clubs"
	
oneDiamond:= SetbackPlayerHand addCard: (sortedDeck at: 50)."ace of hearts"
oneDiamond
	addCard: (sortedDeck at: 8); "10 of spades"
	addCard: (sortedDeck at: 41); "jack of diamonds"
	addCard: (sortedDeck at: 10); "2 of hearts"
	addCard: (sortedDeck at: 11); "2 of clubs"
	addCard: (sortedDeck at: 12). "2 of spades"
	
oneClub:= SetbackPlayerHand addCard: (sortedDeck at: 13). "5 of diamonds"
oneClub 
	addCard: (sortedDeck at: 14); "5 of hearts"
	addCard: (sortedDeck at: 15); "5 of clubs"
	addCard: (sortedDeck at: 16); "5 of spades"
	addCard: (sortedDeck at: 17); "8 of diamonds"
	addCard: (sortedDeck at: 18). "8 of hearts"
	
oneSpade:= SetbackPlayerHand addCard: (sortedDeck at: 19). "8 of clubs"
oneSpade 
	addCard: (sortedDeck at: 20); "8 of spades"
	addCard: (sortedDeck at: 21); "queen of diamonds"
	addCard: (sortedDeck at: 22); "queen of hearts"
	addCard: (sortedDeck at: 23); "queen of clubs"
	addCard: (sortedDeck at: 25). "king of diamonds"! !

SetbackTestCase subclass: #SetbackTrickTest
	instanceVariableNames: 'oneHeart oneClub oneDiamond oneSpade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject-Tests'!

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
setUp
super setUp.

oneHeart:= SetbackPlayerHand new.
oneHeart addCard: (sortedDeck at: 1);
	addCard: (sortedDeck at: 2);
	addCard: (sortedDeck at: 3);
	addCard: (sortedDeck at: 4);
	addCard: (sortedDeck at: 6);
	addCard: (sortedDeck at: 7).
	
oneDiamond:= SetbackPlayerHand new.
oneDiamond addCard: (sortedDeck at: 50);
	addCard: (sortedDeck at: 8);
	addCard: (sortedDeck at: 41);
	addCard: (sortedDeck at: 10);
	addCard: (sortedDeck at: 11);
	addCard: (sortedDeck at: 12).
	
oneClub:= SetbackPlayerHand new.
oneClub addCard: (sortedDeck at: 13);
	addCard: (sortedDeck at: 14);
	addCard: (sortedDeck at: 15);
	addCard: (sortedDeck at: 16);
	addCard: (sortedDeck at: 17);
	addCard: (sortedDeck at: 18).
	
oneSpade:= SetbackPlayerHand new.
oneSpade addCard: (sortedDeck at: 19);
	addCard: (sortedDeck at: 20);
	addCard: (sortedDeck at: 21);
	addCard: (sortedDeck at: 22);
	addCard: (sortedDeck at: 23);
	addCard: (sortedDeck at: 25).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testOpeningTrick
|trick|
"4 of hearts"
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"ace of hearts"
trick playCard: (sortedDeck at: 50) inHand: oneDiamond.
"5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"queen of hearts"
trick playCard: (sortedDeck at: 22) inHand: oneSpade.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #four.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #ace.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCantFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: (trick cards size) = 3.
self assert: (trick leadCard) = (sortedDeck at: 1).
self assert: (trick trumpSuit) = (sortedDeck at: 1) suit.
self assert: (trick winningCard) =  (sortedDeck at: 41).! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCardNotInHand
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart.
trick playCard:  (sortedDeck at: 41) inHand: oneDiamond.
self should: [ trick playCard: (sortedDeck at: 52) inHand: oneDiamond. ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreation
|trick|
trick:= SetbackTrick leadCard: (sortedDeck at: 50) inHand: oneDiamond. 
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickCreationNewGame
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond.
self assert: trick leadCard suit = #hearts.
self assert: trick leadCard value = #ace.
self assert: trick cards size = 1.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickFailToFollowSuit
|trick|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 1) inHand: oneHeart. 
self should: [ trick playCard: (sortedDeck at: 10) inHand: oneDiamond ] raise: TestResult error.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/29/2013 21:17'!
testTrickTrumpIn
|trick|
"Change trump to hearts"
SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 2) inHand: oneHeart.
"create a new trick and lead with 10 of clubs"
trick:= SetbackTrick leadCard: (sortedDeck at: 7) inHand: oneHeart.
"trump in with 5 of hearts"
trick playCard: (sortedDeck at: 14) inHand: oneClub.
"throw a club to follow suit"
trick playCard: (sortedDeck at: 19) inHand: oneSpade.
"throw another trump"
trick playCard: (sortedDeck at: 10) inHand: oneDiamond.
self assert: trick leadCard suit = #clubs.
self assert: trick leadCard value = #ten.
self assert: trick winningCard suit = #hearts.
self assert: trick winningCard value = #five.
self assert: trick cards size = 4.
self assert: trick trumpSuit = #hearts.! !

!SetbackTrickTest methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 12:11'!
testTrickUniqueCards
|trick hand|
trick:= SetbackTrick playFirstCardOfNewGame: (sortedDeck at: 50) inHand: oneDiamond. 
hand:= SetbackPlayerHand addCard: (sortedDeck at: 50).
self assert: (trick playCard: (sortedDeck at: 50) inHand: hand) cards size = 1.! !

Model subclass: #SetbackPlayer
	instanceVariableNames: 'name hand pointsEarned gamePointsWon cardsWon playerId'
	classVariableNames: 'playerIdCounter'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackPlayer commentStamp: '<historical>' prior: 0!
I am a player of a setback game. I can be dealt cards, select a card to play, and win tricks. I keep a tally of the points I earned this game, the cards I have won this hand and the current cards in my hand.!

!SetbackPlayer class methodsFor: 'accessing' stamp: 'TerryTata 6/30/2013 13:39'!
name: aName
(playerIdCounter = nil) ifTrue: [ playerIdCounter:= 0 ].
^self new name: aName! !

!SetbackPlayer methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 12:58'!
= aPlayer
^self playerId = aPlayer playerId! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/6/2013 10:12'!
addToGamePoints: aValue
gamePointsWon:= gamePointsWon + aValue.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/6/2013 17:50'!
addToPointsEarned: somePoints
pointsEarned:= pointsEarned + somePoints.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 6/30/2013 16:36'!
beDealtCard: aCard
hand addCard: aCard! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:40'!
cardsWon
^cardsWon copy! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/2/2013 21:29'!
clearCardsWon
cardsWon removeAll.! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 7/6/2013 10:17'!
gamePointsWon
^gamePointsWon copy! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:34'!
hand
^hand copy! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/3/2013 21:18'!
hand: aHand
"for testing"
hand:= aHand.! !

!SetbackPlayer methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 12:58'!
hash
^playerId hash.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/2/2013 16:37'!
makeBid: aBid
(CardUtility possibleBids includesKey: aBid)
ifFalse: [ self error: 'This bid is not valid!!' ].
self changed: aBid! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:39'!
name
^name copy! !

!SetbackPlayer methodsFor: 'initialize-release' stamp: 'TerryTata 7/6/2013 10:17'!
name: aName
name:= aName.
hand:= SetbackPlayerHand new.
pointsEarned:= 0.
gamePointsWon:= 0.
cardsWon:= Set new.
playerIdCounter:= playerIdCounter+ 1.
playerId:= playerIdCounter.! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 7/2/2013 21:43'!
playCard: aCard
self changed: aCard.
^aCard! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/30/2013 12:58'!
playerId
^playerId copy! !

!SetbackPlayer methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:39'!
pointsEarned
^pointsEarned copy! !

!SetbackPlayer methodsFor: 'actions' stamp: 'TerryTata 6/29/2013 21:43'!
winTrick: someCards
cardsWon addAll: someCards! !

Object subclass: #Card
	instanceVariableNames: 'value suit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!Card commentStamp: '<historical>' prior: 0!
A Card is an instance of a playing card in a standard 52 card french deck.

Instance Variables
	suit:		symbol
	value:		symbol

suit
	- the suit of the card

value
	- the face value, or rank of the card
!

!Card class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 17:32'!
value: aValue suit: aSuit
((CardUtility possibleSuit includes: aSuit) & (CardUtility valueMapping includesKey: aValue))
ifTrue: [ ^self new value: aValue suit: aSuit ]
ifFalse: [ self error: 'Creation of a card is restricted to only valid suits and face values.' ]! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 7/6/2013 08:45'!
< aCard
"returns true if this card has a lower face value of aCard"
^(CardUtility valueMapping at: value) < (CardUtility valueMapping at: aCard value)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/30/2013 13:01'!
= aCard
^(self value = aCard value) & (self suit = aCard suit)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 17:32'!
> aCard
"returns true if this card has a higher face value of aCard"
^(CardUtility valueMapping at: value) > (CardUtility valueMapping at: aCard value)! !

!Card methodsFor: 'comparing' stamp: 'TerryTata 6/29/2013 10:30'!
hash
^value hash bitXor: suit hash! !

!Card methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:37'!
printOn: aStream
(value printOn: aStream). 'of' printOn: aStream. (suit printOn: aStream)! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:14'!
suit
^suit copy! !

!Card methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:14'!
value
^value copy! !

!Card methodsFor: 'private' stamp: 'TerryTata 6/29/2013 10:33'!
value: aValue suit: aSuit
((value = nil) & (suit = nil))
ifTrue: [value:= aValue. suit:= aSuit.]
ifFalse: [ self error: 'Card has already been created!!' ]

! !

Object subclass: #CardUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

CardUtility class
	instanceVariableNames: 'possibleSuit valueMapping possibleBids gameValues'!

!CardUtility commentStamp: '<historical>' prior: 0!
I am a simple utility class to store the possible suits and possible values of a standard playing card.!

CardUtility class
	instanceVariableNames: 'possibleSuit valueMapping possibleBids gameValues'!

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/5/2013 22:01'!
createGameValues
	gameValues := Dictionary new.
	gameValues at: #two put: 0.
	gameValues at: #three put: 0.
	gameValues at: #four put: 0.
	gameValues at: #five put: 0.
	gameValues at: #six put: 0.
	gameValues at: #seven put: 0.
	gameValues at: #eight put: 0.
	gameValues at: #nine put: 0.
	gameValues at: #ten put: 10.
	gameValues at: #jack put: 1.
	gameValues at: #queen put: 2.
	gameValues at: #king put: 3.
	gameValues at: #ace put: 4! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/1/2013 17:19'!
createPossibleBids
	possibleBids := Dictionary new.
	possibleBids at: #pass put: 1.
	possibleBids at: #two put: 2.
	possibleBids at: #three put: 3.
	possibleBids at: #four put: 4.
	possibleBids at: #five put: 5.
	! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:27'!
createPossibleSuits
	possibleSuit := Bag new.
	possibleSuit add: #hearts.
	possibleSuit add: #diamonds.
	possibleSuit add: #clubs.
	possibleSuit add: #spades! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:27'!
createValueMappings
	valueMapping := Dictionary new.
	valueMapping at: #two put: 2.
	valueMapping at: #three put: 3.
	valueMapping at: #four put: 4.
	valueMapping at: #five put: 5.
	valueMapping at: #six put: 6.
	valueMapping at: #seven put: 7.
	valueMapping at: #eight put: 8.
	valueMapping at: #nine put: 9.
	valueMapping at: #ten put: 10.
	valueMapping at: #jack put: 11.
	valueMapping at: #queen put: 12.
	valueMapping at: #king put: 13.
	valueMapping at: #ace put: 14! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/5/2013 21:55'!
gameValues
gameValues= nil
ifTrue: [ self createGameValues ].
^gameValues! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/6/2013 11:54'!
passesAroundTableDuringDeal
^2! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/1/2013 17:28'!
possibleBids
possibleBids = nil
ifTrue: [ self createPossibleBids ].
^possibleBids! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:24'!
possibleSuit
possibleSuit = nil
ifTrue: [ self createPossibleSuits ].
^possibleSuit! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/6/2013 08:43'!
resetAllMappings
possibleSuit:= nil.
valueMapping:=nil. 
possibleBids:= nil. 
gameValues:= nil.! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 7/2/2013 21:08'!
setbackPlayerHandSize
^6! !

!CardUtility class methodsFor: 'class initialization' stamp: 'TerryTata 6/29/2013 15:24'!
valueMapping
valueMapping = nil
ifTrue: [ self createValueMappings ].
^valueMapping! !

Object subclass: #FrenchDeck
	instanceVariableNames: 'cards currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!FrenchDeck commentStamp: '<historical>' prior: 0!
I am the representation of a standard French Deck of playing cards.!

!FrenchDeck class methodsFor: 'private' stamp: 'TerryTata 6/28/2013 15:47'!
createStandardDeck
^self new createStandardDeck! !

!FrenchDeck methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:10'!
cards
^cards copy! !

!FrenchDeck methodsFor: 'private' stamp: 'TerryTata 6/29/2013 17:48'!
createStandardDeck
cards isNil
ifTrue: [ cards:= self populateFrenchDeck. self shuffle. ]
ifFalse: [ self error: 'Deck has already been created. Shuffle deck instead.' ]! !

!FrenchDeck methodsFor: 'dealing' stamp: 'TerryTata 6/28/2013 18:53'!
dealNext
currentIndex:= currentIndex + 1.
^cards at: currentIndex ifAbsent: [ self error: 'The deck has run out of cards!!' ]! !

!FrenchDeck methodsFor: 'private' stamp: 'TerryTata 6/29/2013 17:48'!
populateFrenchDeck
|deck index|
deck:= Array new: 52.
index:= 1.
CardUtility valueMapping keysDo: 
[ :value | CardUtility possibleSuit do: 
	[ :suit | deck at: index put: (Card value: value suit: suit). index:= index + 1.]].
^deck! !

!FrenchDeck methodsFor: 'printing' stamp: 'TerryTata 6/28/2013 18:28'!
printOn: aStream
cards do: [ :card | card printOn: aStream ]! !

!FrenchDeck methodsFor: 'shuffling' stamp: 'TerryTata 6/28/2013 19:42'!
shuffle
cards shuffle.
currentIndex:= 0. ! !

Object subclass: #PlayerConfigStrategy
	instanceVariableNames: 'numberOfPlayers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!PlayerConfigStrategy commentStamp: '<historical>' prior: 0!
A PlayerConfigStrategy is xxxxxxxxx.

Instance Variables
	numberOfPlayers:		<Object>

numberOfPlayers
	- xxxxx
!

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 17:19'!
determinePlayerLimit
^self subclassResponsibility ! !

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:12'!
initialize
self determinePlayerLimit! !

!PlayerConfigStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 18:08'!
players
^numberOfPlayers copy! !

PlayerConfigStrategy subclass: #ThreePlayerStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!ThreePlayerStrategy commentStamp: '<historical>' prior: 0!
A ThreePlayerStrategy is xxxxxxxxx.

Instance Variables
!

!ThreePlayerStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 17:19'!
determinePlayerLimit
numberOfPlayers:= 3.! !

Object subclass: #SetbackGame
	instanceVariableNames: 'players playerConfigStrategy winnerStrategy started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackGame commentStamp: '<historical>' prior: 0!
A SetbackGame is xxxxxxxxx.

Instance Variables
	playerConfigStrategy:		<Object>
	players:		<Object>
	started:		<Object>
	winnerStrategy:		<Object>

playerConfigStrategy
	- xxxxx

players
	- xxxxx

started
	- xxxxx

winnerStrategy
	- xxxxx
!

!SetbackGame class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 19:16'!
setUpGame
^self new playerConfigStrategy: (ThreePlayerStrategy new);
winnerStrategy: (StandardWinStrategy new).! !

!SetbackGame methodsFor: 'adding' stamp: 'TerryTata 6/30/2013 18:07'!
addPlayer: aPlayer
(players size = playerConfigStrategy players)
ifTrue: [ self error: 'You already have the maximum alloted players under your current configuration!!' ].
started 
ifTrue: [ self error: 'You cannot add new players after the game has started!!' ].
players add: aPlayer.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 20:38'!
initialize
players:= LinkedList new.
started:= false.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:26'!
playerConfigStrategy: aConfig
started
ifTrue: [ self error: 'The game has already started. You may not alter the configuration!!' ].
playerConfigStrategy:= aConfig.
! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:08'!
startGame
(players size = playerConfigStrategy players)
ifFalse: [ self error: 'You do not have the proper number of players to start a game!!' ].
started:= true.
self startNewHand.! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 7/6/2013 21:40'!
startNewHand
| winner |
started
ifFalse: [ self error: 'You may not start a new hand if the game hasn''t started!!' ].

SetbackGameHand players: players playerConfig: playerConfigStrategy winnerStrat: winnerStrategy.
winner:= winnerStrategy doWeHaveAWinner: players.

winner = nil
ifFalse: [ Transcript show: 'Congratulations to our winner, ', winner asString, ' !!']
! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 7/2/2013 19:12'!
started
^started copy! !

!SetbackGame methodsFor: 'initialize-release' stamp: 'TerryTata 6/30/2013 18:27'!
winnerStrategy: aWinner
started
ifTrue: [ self error: 'The game has already started. You may not alter the configuration!!' ].
winnerStrategy:= aWinner.
! !

Object subclass: #SetbackGameHand
	instanceVariableNames: 'players playerConfigStrategy winnerStrategy deck trump bidder dealer currentBid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackGameHand commentStamp: '<historical>' prior: 0!
A SetbackGameHand is xxxxxxxxx.

Instance Variables
	bidder:		<Object>
	currentBid:		<Object>
	dealer:		<Object>
	deck:		<Object>
	playerLead:		<Object>
	players:		<Object>
	trump:		<Object>

bidder
	- xxxxx

currentBid
	- xxxxx

dealer
	- xxxxx

deck
	- xxxxx

playerLead
	- xxxxx

players
	- xxxxx

trump
	- xxxxx
!

!SetbackGameHand class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:52'!
players: players playerConfig: aConfig winnerStrat: aWinner
^self new players: players playerConfig: aConfig winnerStrat: aWinner! !

!SetbackGameHand methodsFor: 'accessing' stamp: 'TerryTata 7/2/2013 19:41'!
bidder
^bidder copy! !

!SetbackGameHand methodsFor: 'accessing' stamp: 'TerryTata 7/2/2013 19:45'!
currentBid
^currentBid copy! !

!SetbackGameHand methodsFor: 'accessing' stamp: 'TerryTata 7/2/2013 19:40'!
dealer
^dealer copy! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/2/2013 17:25'!
endBidPhase: aBid by: aBidder
bidder:= aBidder.
currentBid:= aBid! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/2/2013 21:34'!
endTrickPhase: trumpSuit
trump:= trumpSuit.! !

!SetbackGameHand methodsFor: 'accessing' stamp: 'TerryTata 7/2/2013 19:43'!
players
^players copy! !

!SetbackGameHand methodsFor: 'initialize-release' stamp: 'TerryTata 7/2/2013 21:53'!
players: somePlayers playerConfig: aConfig winnerStrat: aWinner
players = nil
ifFalse: [ self error: 'The hand has already started!! You may not change the players!!' ].
players:= somePlayers.
deck:= FrenchDeck createStandardDeck.
"set the order in which bidding will occur, as well as the dealer"
dealer:= players removeFirst.
players add: dealer.
playerConfigStrategy:= aConfig. 
winnerStrategy:= aWinner.! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 21:31'!
startBidPhase
BidPhase players: (players copy) reportTo: self.! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 22:18'!
startDealPhase
DealPhase players: (players copy) deck: deck.
! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 21:33'!
startScorePhase
ScorePhase players: (players copy) trump: trump bidder: bidder bid: currentBid.! !

!SetbackGameHand methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 21:34'!
startTrickPhase
TrickPhase players: (players copy) bidder: bidder playerConfig: playerConfigStrategy reportTo: self.! !

!SetbackGameHand methodsFor: 'accessing' stamp: 'TerryTata 7/2/2013 19:41'!
trump
^trump copy! !

Object subclass: #SetbackGamePhase
	instanceVariableNames: 'players gameHand playerConfigStrategy winnerStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackGamePhase commentStamp: '<historical>' prior: 0!
A SetbackGamePhase is xxxxxxxxx.

Instance Variables
	gameHand:		<Object>
	players:		<Object>

gameHand
	- xxxxx

players
	- xxxxx
!

SetbackGamePhase subclass: #BidPhase
	instanceVariableNames: 'currentBidder winningBidder currentBid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!BidPhase commentStamp: '<historical>' prior: 0!
A BidPhase is xxxxxxxxx.

Instance Variables
	currentBid:		<Object>
	currentBidder:		<Object>
	winningBidder:		<Object>

currentBid
	- xxxxx

currentBidder
	- xxxxx

winningBidder
	- xxxxx
!

!BidPhase class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 17:35'!
players: somePlayers reportTo: aGameHand
^self new players: somePlayers reportTo: aGameHand! !

!BidPhase methodsFor: 'initialize-release' stamp: 'TerryTata 7/2/2013 17:43'!
players: somePlayers reportTo: aGameHand
players:= somePlayers.
currentBid:= #pass.
currentBidder:= nil.
winningBidder:= nil.
gameHand:= aGameHand.
self waitForBid.! !

!BidPhase methodsFor: 'initialize-release' stamp: 'TerryTata 7/2/2013 17:39'!
reportBidStatus
players size = 0
ifTrue: [ gameHand endBidPhase: currentBid by: winningBidder.]! !

!BidPhase methodsFor: 'initialize-release' stamp: 'TerryTata 7/6/2013 17:58'!
update: aSymbol
((currentBid = #pass) & (players size = 0) & (aSymbol = #pass))
"dealer must bid if no one else has"
ifTrue: [ winningBidder:= currentBidder. currentBid:= #two. ]
ifFalse:[
aSymbol = #pass
ifFalse: [
	"check to see if the bid that was made was larger than the last bid"  
	(CardUtility possibleBids at: aSymbol) > (CardUtility possibleBids at: currentBid)
	ifTrue: [ winningBidder:= currentBidder. currentBid:= aSymbol. ].
	"if the dealer is bidding, s/he can steal the bid for the same bid amount"
	(((CardUtility possibleBids at: aSymbol) = (CardUtility possibleBids at: currentBid)) & (players size =  0))
	ifTrue: [ winningBidder:= currentBidder. currentBid:= aSymbol.]]].

currentBidder removeDependent: self.

players size = 0
ifTrue: [  self reportBidStatus.]
ifFalse: [ self waitForBid. ]! !

!BidPhase methodsFor: 'initialize-release' stamp: 'TerryTata 7/2/2013 17:37'!
waitForBid
players size > 0
ifTrue: [  
currentBidder:= players removeFirst.
currentBidder addDependent: self.
]
ifFalse: [ self error: 'All players have had their turn to bid!!' ]! !

SetbackGamePhase subclass: #DealPhase
	instanceVariableNames: 'deck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!DealPhase commentStamp: '<historical>' prior: 0!
A DealPhase is xxxxxxxxx.

Instance Variables
	deck:		<Object>

deck
	- xxxxx
!

!DealPhase class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 22:16'!
players: somePlayers deck: aDeck
^self new players: somePlayers deck: aDeck.! !

!DealPhase methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 22:14'!
dealPlayer: aPlayer
	"deal a player 3 cards each pass"

	1 to: CardUtility setbackPlayerHandSize / CardUtility passesAroundTableDuringDeal do: [ :i | aPlayer beDealtCard: deck dealNext ]! !

!DealPhase methodsFor: 'phases' stamp: 'TerryTata 7/6/2013 22:16'!
players: somePlayers deck: aDeck
players:= somePlayers.
deck:= aDeck.
self startPass.! !

!DealPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 22:14'!
startPass
"two passes around the table"
1 to: (CardUtility passesAroundTableDuringDeal) do: [:i | players do: [ :player | self dealPlayer: player. ]]! !

SetbackGamePhase subclass: #ScorePhase
	instanceVariableNames: 'pointsMapping trump bidder bid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!ScorePhase commentStamp: '<historical>' prior: 0!
A ScorePhase is xxxxxxxxx.

Instance Variables
	currentTrick:		<Object>
	currentTrickCardsThrown:		<Object>
	nextPlayerToThrow:		<Object>
	playerConfigStrategy:		<Object>
	remainingTricks:		<Object>
	trump:		<Object>

currentTrick
	- xxxxx

currentTrickCardsThrown
	- xxxxx

nextPlayerToThrow
	- xxxxx

playerConfigStrategy
	- xxxxx

remainingTricks
	- xxxxx

trump
	- xxxxx
!

!ScorePhase class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/5/2013 21:58'!
players: somePlayers trump: aSuit
^self new players: somePlayers trump: aSuit! !

!ScorePhase class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:11'!
players: somePlayers trump: aSuit bidder: aBidder bid: aBid
^self new players: somePlayers trump: aSuit bidder: aBidder bid: aBid! !

!ScorePhase methodsFor: 'updating' stamp: 'TerryTata 7/6/2013 21:32'!
beginScoring
|bidderValue|
bidderValue:= 0.
players do: [ :player | self calculatePoints: player ].
pointsMapping do: [ :point | bidderValue:= bidderValue + (point awardPoint: bidder) ].

bidderValue >= (CardUtility possibleBids at: bid)
ifTrue: [  bidder addToPointsEarned: bidderValue ]
ifFalse: [ bidder addToPointsEarned: ((CardUtility possibleBids at: bid) * -1) ]! !

!ScorePhase methodsFor: 'updating' stamp: 'TerryTata 7/6/2013 15:17'!
calculatePoints: aPlayer
	aPlayer cardsWon
		do: [ :card | pointsMapping do: [ :point | 
				point doesCardWinPoint: card from: aPlayer ]. ].! !

!ScorePhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:48'!
players: somePlayers trump: aSuit bidder: aBidder bid: aBid
players:= somePlayers.
trump:= aSuit.
bidder:= aBidder.
bid:= aBid.

"four points to hand out"
pointsMapping :=LinkedList new.
pointsMapping add: (HighPoint winningPlayer: nil winningValue: nil trump: aSuit).
pointsMapping add: (LowPoint winningPlayer: nil winningValue: nil trump: aSuit).
pointsMapping add: (GamePoint winningPlayer: nil winningValue: nil trump: aSuit).
pointsMapping add: (JackPoint winningPlayer: nil winningValue: nil trump: aSuit).

self beginScoring.! !

!SetbackGamePhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 22:10'!
advancePhase
^self subclassResponsibility! !

SetbackGamePhase subclass: #TrickPhase
	instanceVariableNames: 'currentTrickCardsThrown nextPlayerToThrow currentTrick trump remainingTricks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!TrickPhase commentStamp: '<historical>' prior: 0!
A TrickPhase is xxxxxxxxx.

Instance Variables
	currentTrickCardsThrown:		<Object>
	nextPlayerToThrow:		<Object>
	remainingTricks:		<Object>

currentTrickCardsThrown
	- xxxxx

nextPlayerToThrow
	- xxxxx

remainingTricks
	- xxxxx
!

!TrickPhase class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:54'!
players: somePlayers bidder: aBidder playerConfig: playerConfigStrategy reportTo: aGameHand
^self new players: somePlayers bidder: aBidder playerConfig: playerConfigStrategy reportTo: aGameHand! !

!TrickPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 18:27'!
players: somePlayers bidder: aBidder playerConfig: aConfig reportTo: aGameHand
players:= somePlayers.
nextPlayerToThrow:= aBidder.
gameHand:= aGameHand.
currentTrickCardsThrown := Dictionary new.
remainingTricks:= CardUtility setbackPlayerHandSize.
trump:= nil.
currentTrick:= nil.
playerConfigStrategy:= aConfig.
self setPlayerOrder.
self waitForCard.! !

!TrickPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:33'!
reportTrickStatus
remainingTricks = 0
ifTrue: [ gameHand endTrickPhase: trump]! !

!TrickPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/2/2013 21:50'!
setPlayerOrder
"sets the traversal order for the current trick about to be played"
|currentHead|
currentHead:= players removeFirst.
currentHead = nextPlayerToThrow
ifTrue: [ players addFirst: currentHead ]
ifFalse: [ players addLast: currentHead. self setPlayerOrder. ]! !

!TrickPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 21:13'!
startNewTrick
nextPlayerToThrow:= currentTrickCardsThrown at: (currentTrick winningCard).
nextPlayerToThrow winTrick: currentTrick cards.
currentTrickCardsThrown:= currentTrickCardsThrown removeAll.
currentTrick:= nil.
remainingTricks:= remainingTricks - 1.
self setPlayerOrder.! !

!TrickPhase methodsFor: 'updating' stamp: 'TerryTata 7/6/2013 21:14'!
update: aCard
"just play the card"
currentTrick ~= nil
ifTrue: [ currentTrick playCard: aCard inHand: (nextPlayerToThrow hand) ].
"first trick of a new game. we're establishing trump!!"
((currentTrick = nil) & (remainingTricks = CardUtility setbackPlayerHandSize))
ifTrue: [ currentTrick:= SetbackTrick playFirstCardOfNewGame: aCard inHand: (nextPlayerToThrow hand). trump:= aCard suit.].
"starting subsequent tricks of  a game"
((currentTrick = nil) & (remainingTricks < CardUtility setbackPlayerHandSize))
ifTrue: [ currentTrick:= SetbackTrick leadCard: aCard inHand: (nextPlayerToThrow hand).].

currentTrickCardsThrown at: aCard put: nextPlayerToThrow.

nextPlayerToThrow removeDependent: self.

currentTrickCardsThrown size >= playerConfigStrategy players
ifTrue: [ self startNewTrick. ].
self waitForCard.! !

!TrickPhase methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 21:08'!
waitForCard
remainingTricks > 0
ifTrue: [ 
	nextPlayerToThrow:= players removeFirst.
	nextPlayerToThrow addDependent: self.
	players add: nextPlayerToThrow.
]
ifFalse: [ self reportTrickStatus. ]! !

Object subclass: #SetbackPlayerHand
	instanceVariableNames: 'cards'
	classVariableNames: 'capacity'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackPlayerHand commentStamp: '<historical>' prior: 0!
I am the representation of a standard setback hand. I contain a maximum of six cards and am owned by exactly one player.!

!SetbackPlayerHand class methodsFor: 'class initialization' stamp: 'TerryTata 7/5/2013 18:50'!
addCard: aCard
capacity:= CardUtility setbackPlayerHandSize.
^self new addCard: aCard.! !

!SetbackPlayerHand methodsFor: 'adding' stamp: 'TerryTata 7/5/2013 18:45'!
addCard: aCard
cards size >= capacity
ifTrue: [ self error: 'Cannot add any more cards to hand!!' ]
ifFalse: [ cards add: aCard. ]
! !

!SetbackPlayerHand methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:11'!
capacity
^capacity copy! !

!SetbackPlayerHand methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:11'!
cards
^cards copy! !

!SetbackPlayerHand methodsFor: 'testing' stamp: 'TerryTata 6/29/2013 19:18'!
includes: aCard
^cards includes: aCard! !

!SetbackPlayerHand methodsFor: 'initialize-release' stamp: 'TerryTata 6/28/2013 20:10'!
initialize
cards:= Set new.! !

!SetbackPlayerHand methodsFor: 'adding' stamp: 'TerryTata 7/2/2013 20:22'!
removeCard: aCard
cards size = 0
ifTrue: [ self error: 'Hand is empty!!' ].
(cards includes: aCard)
ifTrue: [ cards remove: aCard.]
ifFalse: [ self error: 'Card does not exist in hand!!'].! !

!SetbackPlayerHand methodsFor: 'testing' stamp: 'TerryTata 6/29/2013 19:42'!
suitExists: aSuit
^(cards select: [ :each | each suit = aSuit]) isEmpty not! !

Object subclass: #SetbackPoint
	instanceVariableNames: 'winningPlayer winningValue trump'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackPoint commentStamp: '<historical>' prior: 0!
A SetbackPoint is xxxxxxxxx.

Instance Variables
	winningPlayer:		<Object>
	winningValue:		<Object>

winningPlayer
	- xxxxx

winningValue
	- xxxxx
!

SetbackPoint subclass: #GamePoint
	instanceVariableNames: 'duplicateWinner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!GamePoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:50'!
awardPoint: bidder
|bidderPoints|
bidderPoints:= 0.
(winningValue isNil) & (duplicateWinner not)
ifFalse: [ winningPlayer = bidder ifTrue: [bidderPoints:= 1] ifFalse: [winningPlayer addToPointsEarned: 1.] ].
^bidderPoints! !

!GamePoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 15:38'!
doesCardWinPoint: aCard from: aPlayer
|gamePoints|
aPlayer addToGamePoints: (CardUtility gameValues at: (aCard value)).
gamePoints:= aPlayer gamePointsWon.
winningValue isNil
ifTrue: [ super winningPlayer: aPlayer winningValue: gamePoints.]
ifFalse: [ gamePoints > winningValue ifTrue: [ super winningPlayer: aPlayer winningValue: gamePoints. duplicateWinner:= false.].
	gamePoints = winningValue ifTrue: [ duplicateWinner:= true.]  ]! !

SetbackPoint subclass: #HighPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!HighPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 16:13'!
doesCardWinPoint: aCard from: aPlayer
super compareCard: aCard from: aPlayer using: #>
! !

SetbackPoint subclass: #JackPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!JackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 15:37'!
doesCardWinPoint: aCard from: aPlayer
((winningValue isNil) & (aCard value = #jack) & (aCard suit = trump))
ifTrue: [ super winningPlayer: aPlayer winningValue: aCard ]! !

SetbackPoint subclass: #LowPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!LowPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 16:14'!
doesCardWinPoint: aCard from: aPlayer
super compareCard: aCard from: aPlayer using: #<! !

!SetbackPoint class methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:41'!
winningPlayer: aPlayer winningValue: aValue trump: aSuit
^self new winningPlayer: aPlayer winningValue: aValue trump: aSuit! !

!SetbackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:50'!
awardPoint: bidder
|bidderPoints|
bidderPoints:= 0.
(winningValue isNil)
ifFalse: [ winningPlayer = bidder ifTrue: [bidderPoints:= 1] ifFalse: [winningPlayer addToPointsEarned: 1.] ].
^bidderPoints! !

!SetbackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 16:14'!
compareCard: aCard from: aPlayer using: aComparator
aCard suit = trump
ifTrue: [ winningValue isNil
ifTrue: [ self winningPlayer: aPlayer winningValue: aCard ]
ifFalse: [ (aCard perform: aComparator with: winningValue) ifTrue: [ self winningPlayer: aPlayer winningValue: aCard ]]. ]! !

!SetbackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 10:01'!
doesCardWinPoint: aCard from: aPlayer
^self subclassResponsibility ! !

!SetbackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 15:34'!
winningPlayer: aPlayer winningValue: aValue
winningPlayer:= aPlayer.
winningValue:= aValue.! !

!SetbackPoint methodsFor: 'as yet unclassified' stamp: 'TerryTata 7/6/2013 17:40'!
winningPlayer: aPlayer winningValue: aValue trump: aSuit
trump:= aSuit.
winningPlayer:= aPlayer.
winningValue:= aValue.! !

Object subclass: #SetbackTrick
	instanceVariableNames: 'cards leadCard winningCard'
	classVariableNames: 'trumpSuit'
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!SetbackTrick commentStamp: '<historical>' prior: 0!
I am an individual trick of a setback hand. I contain all logic for determining the winning card of a trick based on the current trump suit and the leading suit.!

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 19:52'!
leadCard: aCard inHand: aHand
^self new leadCard: aCard inHand: aHand! !

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 19:53'!
playFirstCardOfNewGame: aCard inHand: aHand
self trump: aCard suit.
^self leadCard: aCard inHand: aHand.! !

!SetbackTrick class methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 17:32'!
trump: aSuit
(CardUtility possibleSuit includes: aSuit)
ifTrue: [ trumpSuit:= aSuit. ]
ifFalse: [ self error: 'An invalid suit was selected as trump' ]! !

!SetbackTrick methodsFor: 'validate' stamp: 'TerryTata 6/29/2013 20:04'!
blessCard: aCard thrownBy: aHand
(aHand includes: aCard)
ifFalse: [ self error: 'You may only play cards that are in your hand!!' ].! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
cards
^cards copy! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
leadCard
^leadCard copy! !

!SetbackTrick methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 20:05'!
leadCard: aCard inHand: aHand
self blessCard: aCard thrownBy: aHand.
"this method should only be called once (when the first card is thrown of a new trick)"
(cards isNil) & (leadCard isNil)
ifTrue: [ cards:= Set new. leadCard:= aCard. winningCard:= leadCard.]
ifFalse: [ self error: 'The lead card has already been thrown!!'].

self playCard: aCard inHand: aHand.! !

!SetbackTrick methodsFor: 'initialize-release' stamp: 'TerryTata 6/29/2013 20:05'!
playCard: aCard inHand: aHand
self blessCard: aCard thrownBy: aHand.
"plays a card in the current trick. Validates the hand to ensure no cheating occured"
aCard suit = trumpSuit
ifTrue: [ self playTrumpCard: aCard. ]
ifFalse: [ (((aHand suitExists: (leadCard suit)) not) | (aCard suit = leadCard suit))
	ifTrue: [self playNonTrumpCard: aCard]
		ifFalse: [self error: 'You must play the lead suit or a trump card!!']].
	
	aHand removeCard: aCard.
! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 13:58'!
playNonTrumpCard: aCard
"plays a trump card in the current trick."
aCard suit = winningCard suit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard.]! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 12:37'!
playNormalCard: aCard
"plays a card in the current trick."
cards add: aCard.
aCard > winningCard 
ifTrue: [ winningCard:= aCard. ]! !

!SetbackTrick methodsFor: 'play-logic' stamp: 'TerryTata 6/29/2013 12:41'!
playTrumpCard: aCard
"plays a trump card in the current trick."
winningCard suit = trumpSuit
ifTrue: [ self playNormalCard: aCard. ]
ifFalse: [ cards add: aCard. winningCard:= aCard ]! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
trumpSuit
^trumpSuit copy! !

!SetbackTrick methodsFor: 'accessing' stamp: 'TerryTata 6/29/2013 21:15'!
winningCard
^winningCard copy! !

Object subclass: #WinnerStrategy
	instanceVariableNames: 'pointsToWin winningMargin bidToWin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!WinnerStrategy commentStamp: '<historical>' prior: 0!
A WinnerStrategy is xxxxxxxxx.

Instance Variables
	bidToWin:		<Object>
	pointsToWin:		<Object>
	winningMargin:		<Object>

bidToWin
	- xxxxx

pointsToWin
	- xxxxx

winningMargin
	- xxxxx
!

WinnerStrategy subclass: #StandardWinStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SetbackProject'!

!StandardWinStrategy commentStamp: '<historical>' prior: 0!
A StandardWinStrategy is xxxxxxxxx.

Instance Variables
!

!StandardWinStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:41'!
doWeHaveAWinner: players
^false.! !

!StandardWinStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:13'!
initialize
pointsToWin:= 11.
winningMargin:= 2. 
bidToWin:= true.! !

!WinnerStrategy methodsFor: 'as yet unclassified' stamp: 'TerryTata 6/30/2013 20:40'!
doWeHaveAWinner: players
^self subclassResponsibility ! !
